<template>
  <div>
    <GI18nCard
      :i18n="i18n"
      :card="card"
      level="second"
      :optional="optional"
      :wiki-entry="wikiEntry"
      @deleteElement="$emit('delete')"
    >
      <template #card-title-append>
        <v-spacer />
        <GDropDownMenu
          i18n="form.addElement"
          :available-elements="availableElements"
          icon="add"
          color="white"
          @addElement="addElement"
        />
      </template>
      <v-row dense>
        <GCol cols="12">
          <div class="mt-4">
            <DccLocalizedTextBlock
              v-model="value.name"
              i18n="dcc.measurementResults.resultType.name"
            />
          </div>
        </GCol>
        <GCol cols="12">
          <GTextField
            v-model="value._attr.refType"
            i18n="dcc.common.attributes.refType"
            attr-ref-type
          />
        </GCol>
      </v-row>
      <QuantityList
        v-if="value.quantity"
        v-model="value"
        :card="true"
        optional
        level="second"
        class="mt-4"
        @delete="deleteElement('quantity')"
      />
      <template v-if="value.list">
        <DccList
          v-for="(_, index) in value.list"
          :key="index"
          v-model="value.list[index]"
          optional
          class="mt-4"
          :class="indexPath + '_' + index + '_' + 'list'"
          :depth="depth + 1"
          :index-path="indexPath + '_' + index"
          @delete="deleteList(index)"
        />
      </template>
      <v-alert
        v-if="!value.quantity && !value.list"
        color="warning"
        icon="warning"
        ><span v-if="depth > 1">{{
          $t("dcc.measurementResults.noQuantityWarning")
        }}</span>
        <span v-else>{{
          $t("dcc.measurementResults.noQuantityOrListWarning")
        }}</span>
      </v-alert>
      <UsedMethodList
        v-if="value.usedMethods"
        id="usedMethodListType"
        v-model="value.usedMethods"
        level="second"
        class="mt-4"
        optional
        @delete="deleteElement('usedMethods')"
      />
      <SoftwareList
        v-if="value.usedSoftware"
        id="softwareListType"
        v-model="value.usedSoftware"
        level="second"
        class="mt-4"
        optional
        @delete="deleteElement('usedSoftware')"
      />
      <MeasuringEquipmentList
        v-if="value.measuringEquipments"
        id="measuringEquipmentListType"
        v-model="value.measuringEquipments"
        level="second"
        class="mt-4"
        optional
        @delete="deleteElement('measuringEquipments')"
      />
      <InfluenceConditionList
        v-if="value.influenceConditions"
        id="influenceConditionListType"
        v-model="value.influenceConditions"
        level="second"
        class="mt-4"
        optional
        @delete="deleteElement('influenceConditions')"
      />
      <StatementList
        v-if="value.measurementMetaData"
        id="measurementMetaDataListType"
        v-model="value.measurementMetaData"
        i18n-base="dcc.common.measurementMetaDataListType"
        class="mt-4"
        level="second"
        optional
        item-key="metaData"
        @delete="deleteElement('measurementMetaData')"
      />
    </GI18nCard>
  </div>
</template>

<script>
import {
  UsedMethodListType,
  SoftwareListType,
  InfluenceConditionListType,
  MeasuringEquipmentListType,
  MeasurementMetaDataListType,
  ListType,
} from "@d-ptb/dcc-js";
import { insertIf } from "~/assets/util/general";
import GTextField from "~/components/App/Form/gTextField";
import GI18nCard from "~/components/App/Common/GI18nCard";
import UsedMethodList from "~/components/DCC/Common/UsedMethodList";
import SoftwareList from "~/components/DCC/Common/SoftwareList";
import MeasuringEquipmentList from "~/components/DCC/MeasurementResults/MeasuringEquipmentList";
import StatementList from "~/components/DCC/Common/StatementList";
import InfluenceConditionList from "~/components/DCC/MeasurementResults/InfluenceConditionList";
import QuantityList from "~/components/DCC/Common/QuantityList";
import GCol from "~/components/App/Common/GCol";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import { validatableMixin } from "@/components/Mixins/validatableMixin";
import GDropDownMenu from "@/components/App/Common/GDropDownMenu";

export default {
  name: "DccList",
  components: {
    GDropDownMenu,
    GI18nCard,
    GTextField,
    MeasuringEquipmentList,
    QuantityList,
    SoftwareList,
    StatementList,
    UsedMethodList,
    InfluenceConditionList,
    GCol,
    DccLocalizedTextBlock,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    i18n: {
      type: String,
      default: "dcc.common.listType.title",
    },
    optional: {
      default: false,
      type: Boolean,
    },
    depth: {
      type: Number,
      default: 0,
    },
    indexPath: String,
    wikiEntry: {
      type: String,
      default: "dccList",
    },
  },
  computed: {
    availableElements() {
      return [
        "listType",
        "quantityType",
        "usedMethodListType",
        "measuringEquipmentListType",
        "softwareListType",
        "influenceConditionListType",
        "measurementMetaDataListType",
      ]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.depth > 1, "listType"),
        ...insertIf(this.value.quantity, "quantityType"),
        ...insertIf(this.value.usedMethods, "usedMethodListType"),
        ...insertIf(
          this.value.measuringEquipments,
          "measuringEquipmentListType"
        ),
        ...insertIf(this.value.usedSoftware, "softwareListType"),
        ...insertIf(
          this.value.influenceConditions,
          "influenceConditionListType"
        ),
        ...insertIf(
          this.value.measurementMetaData,
          "measurementMetaDataListType"
        ),
      ];
    },
    quantityIsPresent() {
      return !!(
        (this.value.quantity && this.value.quantity.length > 0) ||
        (this.value.list && this.value.list[0])
      );
    },
    customRules() {
      return [() => this.quantityIsPresent];
    },
  },
  watch: {
    value() {
      this.validate();
    },
    "value.quantity"() {
      this.validate();
    },
    "value.list"() {
      this.validate();
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "listType":
          this.value.list
            ? this.value.list.push(new ListType())
            : this.$set(this.value, "list", [new ListType()]);
          // scroll to new list element
          this.$nextTick(() => {
            const lists = document.getElementsByClassName(
              this.indexPath + "_" + (this.value.list.length - 1) + "_" + "list"
            );
            lists[lists.length - 1].scrollIntoView({ behavior: "smooth" });
          });
          break;
        case "quantityType":
          this.$set(this.value, "quantity", []);
          break;
        case "usedMethodListType":
          this.$set(this.value, "usedMethods", new UsedMethodListType());
          this.scrollToElement(element);
          break;
        case "measuringEquipmentListType":
          this.$set(
            this.value,
            "measuringEquipments",
            new MeasuringEquipmentListType()
          );
          this.scrollToElement(element);
          break;
        case "softwareListType":
          this.$set(this.value, "usedSoftware", new SoftwareListType());
          this.scrollToElement(element);
          break;
        case "influenceConditionListType":
          this.$set(
            this.value,
            "influenceConditions",
            new InfluenceConditionListType()
          );
          this.scrollToElement(element);
          break;
        case "measurementMetaDataListType":
          this.$set(
            this.value,
            "measurementMetaData",
            new MeasurementMetaDataListType()
          );
          this.scrollToElement(element);
          break;
      }
    },
    scrollToElement(element) {
      this.$nextTick(() => {
        const elt = document.getElementById(element);
        elt.scrollIntoView({ behavior: "smooth" });
      });
    },
    deleteElement(type) {
      confirm(this.$t(`dcc.common.quantityType.${type}.confirmRemove`)) &&
        this.$delete(this.value, type);
    },
    deleteQuantity() {
      confirm(
        this.$t("dcc.measurementResults.resultType.quantity.confirmRemove")
      ) && this.$delete(this.value, "quantity");
    },
    deleteList(index) {
      confirm(
        this.$t("dcc.measurementResults.resultType.list.confirmRemove")
      ) &&
        (this.value.list.length > 1
          ? this.value.list.splice(index, 1)
          : this.$delete(this.value, "list"));
    },
  },
};
</script>
